#include <stdio.h>

// функции и вызовы:

//------------------------------------------

typedef int (*summ_t) ( int );
int summ2( int x ) { return x + 2; }
int summ3( int x ) { return x + 3; }
int summ4( int x ) { return x + 4; }
summ_t funcs[] = { summ2, summ3, summ4 };

//------------------------------------------

void test01( void ) {             // массив функций
   int i;
   printf( "массив функций:\n" ); 
   for( i = 0; i < sizeof( funcs ) / sizeof( funcs[ 0 ] ); i++ )
      printf( "%d ", funcs[ i ]( i ) );
   printf( "\n" ); 
}

//------------------------------------------

void test02( void ) {             // присвоение функций
   int i;
   summ_t summ2_2 = summ2;
   printf( "присвоение функций:\n" ); 
   printf( "%d ", summ2_2( 7 ) );
   for( i = 0; i < sizeof( funcs ) / sizeof( funcs[ 0 ] ); i++ ) {
      summ2_2 = funcs[ i ];
      printf( "%d ", summ2_2( 7 ) );
   }
   printf( "\n" );
}

//------------------------------------------

int call( summ_t func, void *data ) {
   return func( *(int*)data );
}

void set1( int x ) { x++; }
void set2( int* x ) { (*x)++; }

void test03( void ) {             // косвенный вызов
   int i = 3;
   int *pi = &i;
   printf( "косвенный вызов: %d\n", call( summ3, &i ) );
   set1( i );
   printf( "передача параметра: по значению -> %d,", i );
   set2( pi );
   printf( " по ссылке -> %d\n", i ); 
}

//------------------------------------------

#define N 10
typedef struct {
   int x[ N ];
} astruct_t;

void show_ba( astruct_t* b, astruct_t* a ) {
   int i;
   printf( "before: " );
   for( i = 0; i < N; i++ ) 
      printf( "%d%s", b->x[ i ], i != N - 1 ? ", " : ""  );
   printf( " | after: " );
   for( i = 0; i < N; i++ ) 
      printf( "%d%s", a->x[ i ], i != N - 1 ? ", " : ""  );
   printf( "\n" );
}

astruct_t revers( astruct_t s ) { // и параметр и возврат - структуры
   int n, i, j;
   n = sizeof( s ) / sizeof( int );
   for( i = 0, j = n - 1; i < j; i++, j-- ) {
      int var = s.x[ i ];
      s.x[ i ] = s.x[ j ];
      s.x[ j ] = var;
   } 
   return s;
}

void test04( void ) {        
   astruct_t before = {{ 1, 2, 3, 4, 5, 6, 7 }},
             after = {{ 10*(0) }};
   printf( "структурные параметры и возврат вызова:\n" ); 
   show_ba( &before, &after );
   printf( "revers ... ... ...\n" );
   after = revers( before );
   show_ba( &before, &after );
}

//------------------------------------------

int val1 = 123, val2 = 234;
#define PRN \
        printf( "%s : %d , %d\n", __FUNCTION__, val1, val2 )

void level2( int val1, int val2 ) {
   val1 += 11; val2 *= -1; PRN;
} 

void level1( int val1, int val2 ) {
   val1 += 7; val2 *= 3; PRN;
   level2( val1, val2 ); PRN;
} 

void test05( void ) {             // области видимости имён
   printf( "области видимости имён:\n" ); 
   PRN;
   int val1 = 22, val2 = 11;
   PRN;
   level1( val1, val2 );
   PRN;
}

//------------------------------------------

void ( *tests[] )( void ) = {  // последовательность тестов
        test01, test02, test03, test04, test05 //, test06
};
#include "main.c"

